// ColorMixer.java
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
class Volume {
	private int v;
	Volume(int v) {this.v = v; }
	public void setVolume(int v) { 
		v = (v < 0 ? 0 : v > 255 ? 255 : v);
	}
	public int getVolume() { return v; }
}
class VolumeRenderer extends JScrollBar implements TableCellRenderer {
	public VolumeRenderer() { super(JScrollBar.HORIZONTAL); }
	public Component getTableCellRendererComponent(JTable table,
			Object value,
			boolean isSelected,
			boolean hasFocus,
			int row,int column) {
		if (column == 2) {
			setValue(((Volume)value).getVolume());
			return this;
		} else return null;
	}
}
class ColorMixerModel extends AbstractTableModel {
	String h[] = {"Name", "Value", "Volume"};
	Object d[][] = {{"RED", "0",  new Volume(10)},
			   {"GREEN", "0",  new Volume(10)},
			   {"BLUE", "0",  new Volume(10)}};
	public int getRowCount() { return d.length; }
	public int getColumnCount() { return d[0].length; }
	public String getColumnName(int c) { return h[c]; }
	public Object getValueAt(int r, int c) { return d[r][c]; }
	public Class getColumnClass(int c) {
		return (c == 2)? Volume.class : String.class;
	}
}

public class ColorMixer extends JApplet {
	public void init() {
		JTable jt = new JTable(new ColorMixerModel());
		jt.setDefaultRenderer(Volume.class, new VolumeRenderer());
		getContentPane().add(new JScrollPane(jt));
	}
}
// <applet code=ColorMixer width=300 height=100></applet>

