// ColumnModelTest.java
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
class MyColumnModel extends DefaultTableColumnModel {
	protected int sortedIndexOf(TableColumn tc) {
		int cc = getColumnCount();
		String v = tc.getHeaderValue().toString();
		for (int i = 0; i < cc; i++)
			if (v.compareTo(getColumn(i).getHeaderValue().toString()) <= 0)
				return i;
		return cc;
	}
	public void addColumn(TableColumn tc) {
		super.addColumn(tc);
		int i = sortedIndexOf(tc);
		if (i != tc.getModelIndex())
			moveColumn(tc.getModelIndex(), i);
	}
}
public class ColumnModelTest extends JApplet {
	public void init() {
		DefaultTableModel dtm = new DefaultTableModel(
			new String[][] {{"123", "John Rambo", "Math"},
					   {"666", "Jack Ripper", "Bio"},
					   {"013", "Ted Bundy", "Computer"}},
			new String[] {"Id", "Name", "Department"});
		JTable jt = new JTable(dtm, new MyColumnModel());
		jt.createDefaultColumnsFromModel();
		JScrollPane jsp = new JScrollPane(jt);
		getContentPane().add(jsp);
	}
}
// <applet code=ColumnModelTest width=250 height=100></applet>
