// EditableTable.java
import javax.swing.*;
import javax.swing.table.*;
class MyTableModel extends AbstractTableModel {
	String [] h = {"Name", "Grade", "Bad Boy"}; 
	Object [][] d = {{"John Rambo", "A", new Boolean(false)},
			{"Jack Ripper", "B", new Boolean(false)},
			{"Ted Bundy", "F", new Boolean(true)}};
	public int getRowCount() {return d.length;}
	public int getColumnCount() {return h.length;}
	public Object getValueAt(int r, int c) {return d[r][c];}
	public String getColumnName(int c) {return h[c];}
	public Class getColumnClass(int c) {
 		return getValueAt(0, c).getClass();
	}
	public boolean isCellEditable(int r, int c) {return true;}
	public void setValueAt(Object v, int r, int c) { d[r][c] = v;}
}
public class EditableTable extends JApplet {
	public void init(){
		JTable t = new JTable(new MyTableModel());
		t.createDefaultColumnsFromModel();
		JComboBox cb = new JComboBox(new String[]{"A", "B", "C", "D", "F"});
		t.getColumnModel().getColumn(1).setCellEditor(
			new DefaultCellEditor(cb));
		getContentPane().add(new JScrollPane(t));
	}
}
// <applet code=EditableTable width=300 height=100></applet>
