// BrightnessFilter.java
import java.awt.image.*;
class BrightnessFilter extends RGBImageFilter {
	int brightness;
	BrightnessFilter(int b) { brightness = b; }
	public int filterRGB(int x, int y, int rgb) {
		int r = (rgb >> 16) & 0xff;
		int g = (rgb >> 8) & 0xff;
		int b = (rgb >> 0) & 0xff;
		r += (brightness * r) / 100;
		g += (brightness * g) / 100;
		b += (brightness * b) / 100;
		r = Math.min(Math.max(0, r), 255);
		g = Math.min(Math.max(0, g), 255);
		b = Math.min(Math.max(0, b), 255);
		return 0xff000000 | (r << 16) | (g << 8) | (b << 0);
	}
}
