// LightingFilter.java
import java.awt.image.*;
class LightingFilter extends RGBImageFilter {
	int cx, cy, rad;
	double inten, fade;
	public LightingFilter(int x, int y, int r, double i, double f) {
		cx = x; cy = y; rad = r; inten = i; fade = f;
	}
	public int filterRGB(int x, int y, int rgb) {
		double dist = Math.sqrt((x-cx)*(x-cx) + (y-cy)*(y-cy)) - rad;
		dist = (dist < 0.0) ? 0.0 :  dist;
		double t = inten - dist * fade;
		t = (t < 0.0) ? 0.0 : t;
		int red = (int)(((rgb >> 16) & 0xff) * t);
		red = (red > 255) ? 255 : red;
		int green = (int)(((rgb >> 8) & 0xff) * t);
		green = (green > 255) ? 255 : green;
		int blue = (int)((rgb & 0xff) * t);
		blue = (blue > 255) ? 255 : blue;
		int tran = rgb & 0xff000000;	
		return tran + (red << 16) + (green << 8) + blue;
	}
}
