// RotateFilterTest.java
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
class RotateFilter extends ImageFilter {
	public void setDimensions(int width, int height) {
		consumer.setDimensions(height, width);
	}
	public void setHints(int hints) {
		consumer.setHints(hints & ImageConsumer.TOPDOWNLEFTRIGHT 
					+ ImageConsumer.SINGLEPASS));
	}
	public void setPixels(int x, int y, int w, int h, ColorModel m,  
						int [] p, int o, int s) {
		int [] r = new int[p.length];
		for (int i = 0; i < h; i++)
			for (int j = 0; j < w; j++)
				r[j*h + i] = 	p[(i+1)*s - j - 1 + o];
		consumer.setPixels(y, x, h, w, m, r, o, h);
	}
	public void setPixels(int x, int y, int w, int h, ColorModel m, 
						byte[] p, int o, int s) {
		byte[] r = new byte[p.length];
		for (int i = 0; i < h; i++)
			for (int j = 0; j < w; j++)
				r[j*h + i] = 	p[(i+1)*s - j - 1 + o];
		consumer.setPixels(y, x, h, w, m, r, o, h);
	}
}
public class RotateFilterTest extends java.applet.Applet {
	Image i;
	public void init() {
		ImageIcon ii = new ImageIcon("images/Bird.gif");
		i = ii.getImage();
		i = createImage(new FilteredImageSource(i.getSource(), 
					new RotateFilter()));
	}
	public void paint(Graphics g) {
		g.drawImage(i, 5, 0, this);
	}
}
// <applet code=RotateFilterTest width=110 height=110></applet>
